function [best_unbal, best_uneco, best_Psummax, elite, generation, last_population, data] = ga( ...
    number_of_variables, ...    % Ĳ
    fitness_function, ...       % ԶӦȺ
    population_size, ...        % ȺģÿһĿ
    parent_number, ...          % ÿһбֲĿ⣩
    mutation_rate, ...          % 
    maximal_generation, ...     % ݻ
    minimal_cost ...            % СĿֵĿֵԽСӦԽߣ
)

% ۼӸ 1Ϊparent_number
%  parent_number = 5
%  parent_number:-1:1      [5     4     3     2     1]
% ĸ sum(parent_number:-1:1) 15
% ۼӸ 0.3333    0.6000    0.8000    0.9333    1.0000
% ȵۼӸʿʹǰױѡŴӴ
cumulative_probabilities = cumsum((parent_number:-1:1) / sum(parent_number:-1:1));

% ÿһСƽܶСùܶ ȫʼΪ1
best_unbal = ones(maximal_generation, 1);
best_uneco = ones(maximal_generation, 1);
best_Psummax = ones(maximal_generation, 1);

% ÿһľӢ ȫʼΪ0
elite = zeros(maximal_generation, number_of_variables);

% Ӵ = Ⱥ - ״״ÿһвıĸ壩
child_number = population_size - parent_number;

% ʼȺ
% population_size ӦУÿһбʾ1壬=Ⱥ
% number_of_variables ӦУ=Щʾ
info = readpipe;
WandH = info(:,5:6);
pipecode = encodepipe(cell2mat(WandH));
population = [pipecode; 1 + round(31 * rand(population_size - 1, number_of_variables))];

% ִнָŴ
for generation = 1 : maximal_generation
    % feval: populationinfofitness_functionиӦȣpopulation_size*1ľ
    [unbal,uneco,Psummax,~] = feval(fitness_function, population, info); 

    % иĲƽܶСС
    [unbal, index] = sort(unbal); 
    uneco = uneco(index);
    Psummax = Psummax(index);
    population = population(index(1:parent_number), :); % ȱһֽŵĸ

    % ¼вƽܶСĲƽܶùܶ,
    best_unbal(generation) = unbal(1);
    best_uneco(generation) = uneco(1);
    best_Psummax(generation) = Psummax(1);

    % populationһΪľӢ
    elite(generation, :) = population(1, :); % ¼Ž⣨Ӣ

    % Ž㹻ãֹͣݻ
    if nargin == 7
        if best_unbal(generation) < minimal_cost
            last_population = population;
            break; 
        end
    end

    % 
    for child = 1:2:child_number % Ϊ2Ϊÿһν2Ӵ
        
        % cumulative_probabilitiesΪparent_number
        % ѡ2״  (child+parent_number)%parent_number
        mother = find(cumulative_probabilities > rand, 1); % ѡһ״a
        father = find(cumulative_probabilities > rand, 1); % ѡһ״b
        
        % ceil컨壩ȡ
        % rand һ
        % ѡһУһеֵ
        crossover_point = ceil(rand*number_of_variables); % ȷһȾɫ彻
        
        % crossover_point=3, number_of_variables=5
        % mask1 = 1     1     1     0     0
        % mask2 = 0     0     0     1     1
        mask1 = [ones(1, crossover_point), zeros(1, number_of_variables - crossover_point)];
        mask2 = not(mask1);
        
        % ȡֿ4Ⱦɫ
        % ע .*
        mother_1 = mask1 .* population(mother, :); % ״aȾɫǰ
        mother_2 = mask2 .* population(mother, :); % ״aȾɫĺ󲿷
        
        father_1 = mask1 .* population(father, :); % ״bȾɫǰ
        father_2 = mask2 .* population(father, :); % ״bȾɫĺ󲿷
        
        % õӴ
        population(parent_number + child, :) = mother_1 + father_2; % Ӵa
        population(parent_number+child+1, :) = mother_2 + father_1; % Ӵb
        
    end
    
    
    % 
    mutation_population = population(2:population_size, :); % Ӣ죬2ʼ
    number_of_elements = (population_size - 1) * number_of_variables; % ȫĿ
    number_of_mutations = ceil(number_of_elements * mutation_rate); % ĻĿ*ʣ
    
    % rand(1, number_of_mutations) number_of_mutations(Χ0-1)ɵľ(1*number_of_mutations)
    % ˺󣬾ÿԪرʾıĻλãԪھеһά꣩
    mutation_points = ceil(number_of_elements * rand(1, number_of_mutations)); % ȷҪĻ
    
    % ѡеĻб
    mutation_population(mutation_points) = 1 + round(31 * rand(1, number_of_mutations));
    population(2:population_size, :) = mutation_population; % ֮Ⱥ
    population(population > 32) = 32;
    population(population < 1) = 1;

fprintf('generation: %d; Minimum number of unbalanced pipes: %d\n', generation, best_unbal(generation));
end

last_population = population(1,:);
[~,~,~,data] = feval(fitness_function, last_population, info);
end